float playerX;
float playerY;
float playerSize = 20;
int enemyCount = 100;
float[] enemyXList = new float[enemyCount];
float[] enemyYList = new float[enemyCount];
boolean[] enemyActiveList = new boolean[enemyCount];
float[] enemySpeedList = new float[enemyCount];
float[] enemySizeList = new float[enemyCount];
color[] enemyColorList = new color[enemyCount];
void setup(){
  size(600, 400);
  for(int i = 0; i < enemyCount; i++){
    enemyXList[i] = 0;
    enemyYList[i] = random(0, height);
    enemyActiveList[i] = false;
    enemySpeedList[i] = random(1, 3);
    enemySizeList[i] = random(10, 30);
    enemyColorList[i] = color(random(256), random(256), random(256));
  }
} 
void draw(){
  background(0);
  playerX = mouseX;
  playerY = mouseY;
  for(int i = 0; i < enemyCount; i++){
    if(enemyActiveList[i] == true){
      enemyXList[i] += enemySpeedList[i];
      if(isHit(playerX, playerY, playerSize,
          enemyXList[i], enemyYList[i], enemySizeList[i])){
        playerSize = playerSize + 1;
        enemyActiveList[i] = false;
      }       
      noStroke();
      fill(enemyColorList[i]);
      ellipse(enemyXList[i], enemyYList[i],
          enemySizeList[i], enemySizeList[i]);
    }
  }
  noStroke();
  fill(255);
  ellipse(playerX, playerY, playerSize, playerSize);
}
void mousePressed(){
  for(int i = 0; i < enemyCount; i++){
    if(enemyActiveList[i] == false){
      enemyActiveList[i] = true;
      break;
    }
  }
}
boolean isHit(float px, float py, float ps,
              float ex, float ey, float es){
  float distance = dist(px, py, ex, ey);
  if(distance < ps / 2 + es / 2){
    return true;
  }
  return false;
}
